unit MnUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, XPMan, ComCtrls, ToolWin, ImgList;

type
  TFrMain = class(TForm)
    MainMenu1: TMainMenu;
    Fichier1: TMenuItem;
    Sudoku1: TMenuItem;
    Nouveaugrille1: TMenuItem;
    Rezoudr1: TMenuItem;
    N1: TMenuItem;
    Solveur1: TMenuItem;
    Nouveau1: TMenuItem;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    O1: TMenuItem;
    N2: TMenuItem;
    Enregistrer1: TMenuItem;
    Enregistrersous1: TMenuItem;
    N3: TMenuItem;
    Fermer1: TMenuItem;
    Fermertou1: TMenuItem;
    Effacerlasolution1: TMenuItem;
    XPManifest1: TXPManifest;
    ImageList1: TImageList;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ImageList2: TImageList;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    TbAbout: TToolButton;
    procedure Nouveau1Click(Sender: TObject);
    procedure Nouveaugrille1Click(Sender: TObject);
    procedure Rezoudr1Click(Sender: TObject);
    procedure Enregistrersous1Click(Sender: TObject);
    procedure Enregistrer1Click(Sender: TObject);
    procedure Fermer1Click(Sender: TObject);
    procedure Fermertou1Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
    procedure Solveur1Click(Sender: TObject);
    procedure Effacerlasolution1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure TbAboutClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
    nbrMaskedCell : Integer; // nbr de cellule  masquer, applique lors de gnration des grilles
  end;

var
  FrMain: TFrMain;

implementation

uses Unit1, UnAbout, UnNbrCasesdlg;

{$R *.dfm}

procedure TFrMain.Effacerlasolution1Click(Sender: TObject);
begin
if MDIChildCount = 0 then exit;

(ActiveMDIChild AS TFrGrille).StatusBar1.Panels[1].Text := '';

(ActiveMDIChild as TFrGrille).ViderGrilleSol((ActiveMDIChild as TFrGrille).TempTap);
(ActiveMDIChild as TFrGrille).StringGrid1.Repaint;
end;

procedure TFrMain.Enregistrer1Click(Sender: TObject);
begin
if MDIChildCount <= 0 then exit;

if ((ActiveMDIChild as TFrGrille).SuFichier = '') or (not FileExists((ActiveMDIChild as TFrGrille).SuFichier))then
 begin
   Enregistrersous1Click(Sender);
   Exit;
 end;
 (ActiveMDIChild as TFrGrille).SaveToFile(FrGrille.SuFichier,false);

end;

procedure TFrMain.Enregistrersous1Click(Sender: TObject);
begin
if MDIChildCount <= 0 then exit;

if SaveDlg.Execute then
  begin
    (ActiveMDIChild as TFrGrille).SaveToFile(SaveDlg.FileName,False);
    (ActiveMDIChild as TFrGrille).SuFichier := SaveDlg.FileName;
  end;



end;

procedure TFrMain.Fermer1Click(Sender: TObject);
begin
ActiveMDIChild.Free;
end;

procedure TFrMain.Fermertou1Click(Sender: TObject);
var
  i : Integer;
begin
for I := MDIChildCount -1 Downto 0 do
  MDIChildren[i].Close;
  
end;

procedure TFrMain.FormCreate(Sender: TObject);
begin
nbrMaskedCell := 40;
end;

procedure TFrMain.Nouveau1Click(Sender: TObject);
begin
FrGrille := TFrGrille.Create(Self);
FrGrille.SuState := ssSaisie;
end;

procedure TFrMain.Nouveaugrille1Click(Sender: TObject);
var
 Line,Col : Integer;
begin
IF MDIChildCount  = 0 then Exit;
//if FrGrille = nil then Exit;

FrNbrCasesDlg := TFrNbrCasesDlg.Create(nil);
if FrNbrCasesDlg.ShowModal <> mrOk  then
  begin
    FrNbrCasesDlg.Free;
    Exit;
  end;
nbrMaskedCell := FrNbrCasesDlg.UpDown1.Position;
FrNbrCasesDlg.Free;

(ActiveMDIChild AS TFrGrille).StatusBar1.Panels[1].Text := '';
for Line := 1 to 9 do
  for Col := 1 to 9 do
   begin
   (ActiveMDIChild AS TFrGrille).Bloque[Line,Col] := False;
     (ActiveMDIChild AS TFrGrille).TempTap[Line,Col] := '';

   end;


  if (ActiveMDIChild AS TFrGrille).Generergrille(FrGrille.TempTap) then
    begin
      //(ActiveMDIChild AS TFrGrille).AffectationTableau((ActiveMDIChild AS TFrGrille).TempTap,(ActiveMDIChild AS TFrGrille).Solution);
      (ActiveMDIChild AS TFrGrille).Masquage((ActiveMDIChild AS TFrGrille).TempTap,nbrMaskedCell,(ActiveMDIChild AS TFrGrille).TempTap);   //Tableau    // POUR MASQUER 36 CELLULES
      //(ActiveMDIChild AS TFrGrille).AffectationTableau((ActiveMDIChild AS TFrGrille).Tableau,(ActiveMDIChild AS TFrGrille).TempTap);
      for Line := 1 to 9 do
        for Col := 1 to 9 do
         begin
           //(ActiveMDIChild AS TFrGrille).Bloque[Line,Col] := ((ActiveMDIChild AS TFrGrille).Tableau[Line,Col]<> '');
           (ActiveMDIChild AS TFrGrille).Bloque[Line,Col] := ((ActiveMDIChild AS TFrGrille).TempTap[Line,Col]<> '');
         end;
      (ActiveMDIChild AS TFrGrille).SuState := ssSol;
      (ActiveMDIChild AS TFrGrille).StringGrid1.Repaint;
    end;
end;

procedure TFrMain.O1Click(Sender: TObject);
begin
 if OpenDlg.Execute then
   begin
     TFrGrille.Create(Self);
     (ActiveMDIChild as TFrGrille). LoadFromFile(OpenDlg.FileName);
   end;
end;

procedure TFrMain.Rezoudr1Click(Sender: TObject);
VAR
  TStart,TEnd,Tick : Int64;
  D : Cardinal;
  M,S,MS : Integer;// Minutes, Secondes, M. Seconde
  Temps : string;
begin
   if MDIChildCount = 0 then exit;

  if (ActiveMDIChild AS TFrGrille).IsEmpetyGrid((ActiveMDIChild AS TFrGrille).TempTap) then  Exit;

  (ActiveMDIChild AS TFrGrille).SuState := ssSolAu;
  QueryPerformanceCounter(TStart);
  (ActiveMDIChild AS TFrGrille).Generergrille((ActiveMDIChild AS TFrGrille).TempTap,True);// pour completer (resoudre) la grille
  QueryPerformanceCounter(TEnd);
  QueryPerformanceFrequency(Tick);
  (ActiveMDIChild AS TFrGrille).StringGrid1.Repaint;
  

  D := Round((Tend - TStart)/Tick * 10000000);


  Temps := FormatFloat('#,##0',D)+' us';
  (ActiveMDIChild AS TFrGrille).StatusBar1.Panels[1].Text := 'Temps : '+ Temps;

end;
                                             
procedure TFrMain.Solveur1Click(Sender: TObject);
var
  Line, col :Integer;
begin
if MDIChildCount = 0 then exit;
(ActiveMDIChild AS TFrGrille).StatusBar1.Panels[1].Text := '';
(ActiveMDIChild as TFrGrille).SuState := ssSaisie;
(ActiveMDIChild as TFrGrille).ViderGrille((ActiveMDIChild as TFrGrille).TempTap);
  for Line := 1 to 9 do
    for Col := 1 to 9 do
      (ActiveMDIChild as TFrGrille).Bloque[Line,Col] := false;

(ActiveMDIChild as TFrGrille).StringGrid1.Repaint;

end;

procedure TFrMain.TbAboutClick(Sender: TObject);
begin
FrAbout := TFrAbout.Create(nil);
FrAbout.ShowModal;
end;

procedure TFrMain.ToolButton11Click(Sender: TObject);
begin
Fermer1.Click;
end;

procedure TFrMain.ToolButton1Click(Sender: TObject);
begin
Nouveau1.Click;
end;

procedure TFrMain.ToolButton2Click(Sender: TObject);
begin
O1.Click;
end;

procedure TFrMain.ToolButton3Click(Sender: TObject);
begin
Enregistrer1.Click;
end;

procedure TFrMain.ToolButton5Click(Sender: TObject);
begin
Nouveaugrille1.Click;
end;

procedure TFrMain.ToolButton6Click(Sender: TObject);
begin
Solveur1.Click;
end;

procedure TFrMain.ToolButton7Click(Sender: TObject);
begin
Effacerlasolution1.Click;
end;

procedure TFrMain.ToolButton9Click(Sender: TObject);
begin
Rezoudr1.Click;
end;

end.
